<template>
  <div
    class="content"
    role="main"
  >
    <section class="header">
      <div v-if="amoId" class="info">
        <p>Вы авторизованны по ID: {{ amoId }}</p>
        <a-button class="auth" @click="auth">Авторизоваться еще раз</a-button>
        <a-button class="auth" @click="sync">Принудительно синхронизировать</a-button>
      </div>
      <div v-else class="info">
        <p>Вы не авторизованны</p>
        <a-button class="auth" @click="auth">Авторизоваться</a-button>
      </div>
      <a-input-search
          v-model:value="query"
          @change="inputSearch"
          placeholder="Введите текст для поиска"
          :loading="isLoading"
          allowClear
          style="width: 30%" />
      <a-select
          ref="select"
          v-model:value="pipelineId"
          style="width: 120px"
          :options="pipelinesOptions"
          @change="onChangePipeline"
          placeholder="Выберите воронку"
          :loading="isLoading"
          :disabled="isLoading"
      ></a-select>
    </section>

    <a-spin
        :spinning="isLoading"
        class="loader"
        size="large">
      <a-table
        :columns="columns"
        :data-source="dataSource"
        bordered
            >
        <template #bodyCell="{ column, record }">
          <template v-if="column.key === 'name'">
            <div class="cell-content">
              <p class="clickableText" @click="search(record.name)">{{ record.name }}</p>
                <div class="tags" v-if="record.tags && record.tags.length > 1">
                  <a-tag
                      v-for="tag in record.tags"
                      class="tag clickableText"
                      :key="tag.id"
                      @click="search(tag.name)">
                    {{ tag.name }}
                  </a-tag>
                </div>
            </div>
          </template>
          <template v-else-if="column.key === 'status_text'">
            <div class="cell-content">
              <a-tag
                  class="chip-status clickableText"
                  :color="record.color"
                  @click="search(record.status_text)">
                {{ record.status_text }}
              </a-tag>
            </div>
          </template>
          <template v-else-if="column.key === 'responsible_user_text'">
            <p class="clickableText" @click="search(record.responsible_user_text)">{{ record.responsible_user_text }}</p>
          </template>
          <template v-else-if="column.key === 'created_at_formatted'">
            <p class="clickableText" @click="search(record.created_at)">{{ record.created_at_formatted }}</p>
          </template>
          <template v-else-if="column.key === 'price_formatted'">
            <p class="clickableText" @click="search(record.price_formatted)">{{ record.price_formatted }}</p>
          </template>
        </template>

        <template #expandedRowRender="{ record }">
          <div class="contacts" v-for="contact in record.contacts"  :key="contact.id">
            <a-avatar class="avatar">
              <template #icon>
                <UserOutlined />
              </template>
            </a-avatar>
            <p class="clickableText" @click="search(contact.name)">{{ contact.name }}</p>
            <template v-if="contact.custom_fields_values.length > 1">
              <a
                  v-for="field in contact.custom_fields_values.filter((x) => x.field_code === 'PHONE' || x.field_code === 'MAIL' || x.field_code === 'EMAIL')"
                  :key="field.field_id"
                  :href="field.field_code === 'PHONE' ? 'tel:'+field.values[0].value : 'mailto:'+field.values[0].value"
                  aria-label="Call">
                <a-divider type="vertical" />
                <phone-outlined v-if="field.field_code === 'PHONE'" two-tone-color="#eb2f96"/>
                <mail-outlined v-else/>
              </a>
            </template>
          </div>
        </template>
      </a-table>
    </a-spin>

    <section v-if="errorText" class="error">
      <h1>Ошибка</h1>
      <p>{{ errorText }}</p>
    </section>
  </div>
</template>

<script setup lang="ts">
import { Avatar, Form, Table, Spin, Tag, Divider, Button, Select, SelectProps, Input } from 'ant-design-vue';
import { PhoneOutlined, MailOutlined, UserOutlined } from '@ant-design/icons-vue';
import { getCurrentInstance, ref, onMounted } from "vue";
import axios from "axios";
import { IGetDataResponse } from "./interfaces/IGetDataResponse";
import { IMessage } from "./interfaces/IMessage";
import { environment } from "./environments/environment";
import { IUser } from "./interfaces/IUser";
import { IPipeline } from "./interfaces/IPipeline";
import { ILead } from "./interfaces/ILead";

const { app } = getCurrentInstance()!.appContext;
app.use(Avatar);
app.use(Form);
app.use(Table);
app.use(Spin);
app.use(Tag);
app.use(Divider);
app.use(Button);
app.use(Select);
app.use(Input);

const columns = ref([
  {
    title: 'Название',
    dataIndex: 'name',
    key: 'name',
    width: '35%',
  },
  {
    title: 'Статус',
    dataIndex: 'status_text',
    key: 'status_text',
    width: '15%',
  },
  {
    title: 'Ответственный',
    dataIndex: 'responsible_user_text',
    key: 'responsible_user_text',
    width: '15%',
  },
  {
    title: 'Дата создания',
    dataIndex: 'created_at_formatted',
    key: 'created_at_formatted',
  },
  {
    title: 'Бюджет',
    dataIndex: 'price_formatted',
    key: 'price_formatted',
  },
]);
const pipelines = ref<IPipeline[]>([]);
const pipelinesOptions = ref<SelectProps['options']>([]);
const dataSource = ref([] as ILead[]);
const dataUsers = ref([] as IUser[]);
const dataStatuses = ref();
const isLoading = ref(false);
const errorText = ref('');
const query = ref('');
const amoId = ref(localStorage.getItem('amoId'));
const pipelineId = ref(localStorage.getItem('pipelineId'));

const auth = () => {
  window.location.href= `https://www.amocrm.ru/oauth?client_id=${environment.client_id}&state=post_message&mode=post_message`;
}

const search = (text: string) => {
  query.value = text;
  getData();
}

const onChangePipeline = (value: string | null) => {
  if (!value || value === 'undefined') {
    value = String(pipelines.value[0].id);
    pipelineId.value = value;
  }
  dataStatuses.value = pipelines.value!.find((x) => x.id === Number(value))?.statuses;
  getData();
};

let timeout: number | null;
const inputSearch = (e: any) => {
  if (timeout) {
    clearTimeout(timeout);
    timeout = null;
  }
  timeout = setTimeout(() => {
    getData();
    timeout = null;
  }, 1000)
}

const sync = async () => {
  if(!amoId.value) {
    handleError({message: 'Вы не авторизованны'});
    return;
  }
  try {
    isLoading.value = true;
    let { data } = await axios.post(
        environment.api_uri + `/api/syncAll?amoId=${amoId.value}`,
        {
          headers: {
            'Content-Type': 'application/json'
          }
        }
    )
    console.log(data);
    await getPipelines();
    onChangePipeline(localStorage.getItem('pipelineId'));
    errorText.value = '';
  } catch (e: any) {
    handleError(e);
  } finally {
    isLoading.value = false;
  }
}

const getData = async () => {
  if(!amoId.value) {
    handleError({message: 'Вы не авторизованны'});
    return;
  }
  try {
    isLoading.value = true;
    let { data } = await axios.get<IGetDataResponse | IMessage>(
        environment.api_uri + `/api/getData?amoId=${amoId.value}&pipelineId=${pipelineId.value}&query=${query.value}`,
        {
          headers: {
            'Content-Type': 'application/json'
          }
        }
    )
    console.log(data);
    checkDataError(data);
    data = data as IGetDataResponse;
    dataUsers.value = data.users as IUser[];
    dataSource.value = (data.leads as ILead[]).filter((lead) => {
      const status = dataStatuses.value.find(
          (x: { id: any; }) => x.id === lead.status_id
      );
      if(status) return true;
    }).map((lead) => {
      const status = dataStatuses.value.find(
          (x: { id: any; }) => x.id === lead.status_id
      );
      if(status) {
        lead.status_text = status!.name;
        lead.color = status!.color;
      }
      lead.responsible_user_text = dataUsers.value.find(
          (x) => x.id === lead.responsible_user_id
      )!.name!;
      lead.created_at_formatted = new Date(
          lead.created_at * 1000
      ).toLocaleDateString('ru-RU', {
        year: 'numeric',
        month: 'long',
        day: 'numeric',
      });
      lead.price_formatted = lead.price.toLocaleString('ru-RU', {
        style: 'currency',
        currency: 'RUB',
      });
      lead.key = lead.id;
      return lead;
    });
    errorText.value = '';
  } catch (e: any) {
    handleError(e);
  } finally {
    isLoading.value = false;
  }
}

const getPipelines = async (): Promise<void> => {
  if(!amoId.value) {
    handleError({message: 'Вы не авторизованны'});
    return;
  }
  try {
    isLoading.value = true;
    let { data } = await axios.get<IPipeline[]>(
        environment.api_uri + `/api/getPipelines?amoId=${amoId.value}`,
        {
          headers: {
            'Content-Type': 'application/json'
          }
        }
    )
    console.log(data);
    pipelines.value = data;
    for (const pipeline of data) {
      pipelinesOptions.value!.push({value: pipeline.id, label: pipeline.name});
    }
    errorText.value = '';
  } catch (e: any) {
    handleError(e);
  } finally {
    isLoading.value = false;
  }
  return;
}

const checkDataError = (data: IGetDataResponse | IMessage) => {
  if ('type' in data && data.type === 'message') {
    throw new Error(data.message);
  }
  data = data as IGetDataResponse;
  if (!data.leads || !data.users) {
    if (!data.leads) {
      throw new Error('Не смогли получить лиды');
    } else if (!data.users) {
      throw new Error('Не смогли получить пользователей');
    }
  }
  if ('type' in data.leads && data.leads.type === 'message') {
    throw new Error(data.leads.message);
  } else if ('type' in data.users && data.users.type === 'message') {
    throw new Error(data.users.message);
  }
}

onMounted(async () => {
  const params = new URLSearchParams(window.location.search);
  const id = params.get('amoId');
  if (id) {
    amoId.value = id;
    localStorage.setItem('amoId', String(id));
  }
  if(!amoId.value) {
    handleError({message: 'Вы не авторизованны'});
    return;
  }
  await getPipelines();
  onChangePipeline(localStorage.getItem('pipelineId'));
});

const handleError = (e: any) => {
  console.log(e);
  dataSource.value = [];
  errorText.value = e.message;
}
</script>

<style scoped lang="less">
p {
  margin: 0;
}
.loader {
  height: 10px;
}
.clickableText {
  cursor: pointer;
  display: initial;
}
.clickableText:hover {
  color: #4169E1;
}
.content {
  padding-top: 4vw;
  padding-left: 10vw;
  padding-right: 10vw;
  background-color: rgb(230, 230, 230);
  min-height: 100vh;
  box-sizing: border-box;

  .header {
    padding: 10px 20px;
    display: flex;
    justify-content: space-between;
    align-items: center;
    background-color: rgb(250, 250, 250);
    margin-bottom: 30px;

    .info {
      align-items: center;
      text-align: center;
      display: flex;

      .auth {
        margin-left: 10px;
      }
    }

    .form-field {
      width: 30%;
      color: white;
    }
  }

  .cell-content {
    display: flex;
    align-items: center;
    margin-top: 15px;
    margin-bottom: 15px;
    padding: 6px;
    border-radius: 1px;
    width: fit-content;

    .chip-status {
      padding: 5px 8px;
      border-radius: 1px;
      box-sizing: border-box;
      height: auto;
      color: black;
    }

    .tags {
      margin-left: 20px;
      font-size: 10px;

      .tag {
        font-size: 10px;
        padding: 10px 14px;
        line-height: 50%;
        border-radius: 1px;
        min-height: 15px;
        height: auto;
      }

    }
  }

  .contacts {
    margin-bottom : 15px;
    margin-left: 50px;
    .avatar {
      margin-right: 15px;
    }
  }

  .error {
    padding: 10px 20px;
    display: flex;
    align-items: center;
    background-color: rgb(255, 50, 60);
    position: fixed;
    bottom: 0;
    width: 80vw;

    h1 {
      color: white;
      margin: 0 20px 0 0;
    }

    p {
      color: white;
    }

  }
}
</style>
